/*
 * Generated source file, not in CVS/SVN repository
 */
package org.jcoderz.commons;

import java.io.Serializable;

/**
 * 
 *
 * 
         The given argument is at least partly malformed.
         Argument ''{ARGUMENT_NAME}'' cannot be set to
         value ''{Serializable:ARGUMENT_VALUE}''. The value
         has {Number:ARGUMENT_FRACTION_DIGITS} fraction digits and
         exceeds the allowed maximum {Number:MAX_FRACTION_DIGITS}
         for {Class:ARGUMENT_CLASS}.
      
 *
 * This exception encapsulates the log message
 * {@link org.jcoderz.commons.RteLogMessage#ARGUMENT_FRACTION_DIGITS_VIOLATION}.
 *
 * @author generated
 */
public  class ArgumentFractionDigitsViolationException
      extends org.jcoderz.commons.ArgumentMalformedException
{
   /** use this serialVersionUID for serialization. */
   static final long serialVersionUID = 1L;

   
   private final String mArgumentName;
      
   private final Serializable mArgumentValue;
      
   private final Number mArgumentFractionDigits;
      
   private final Number mMaxFractionDigits;
      
   private final Class mArgumentClass;
      

   /**
    * Constructs a argument fraction digits violation exception with a <tt>cause</tt>.
       * @param argumentName The argument name used in the message.
       * @param argumentValue The argument value used in the message.
       * @param argumentFractionDigits The argument fraction digits used in the message.
       * @param maxFractionDigits The max fraction digits used in the message.
       * @param argumentClass The argument class used in the message.
    * @param cause the cause of this exception.
    */
   public ArgumentFractionDigitsViolationException (String argumentName, Serializable argumentValue, Number argumentFractionDigits, Number maxFractionDigits, Class argumentClass, Throwable cause)
   {
      super(RteLogMessage.ARGUMENT_FRACTION_DIGITS_VIOLATION, cause);
      mArgumentName = argumentName;
      mArgumentValue = argumentValue;
      mArgumentFractionDigits = argumentFractionDigits;
      mMaxFractionDigits = maxFractionDigits;
      mArgumentClass = argumentClass;
      RteLogMessage.ArgumentFractionDigitsViolation.addParameters(this,
         argumentName, argumentValue, argumentFractionDigits, maxFractionDigits, argumentClass);
      logCreation();
   }

   /**
    * Constructs a argument fraction digits violation exception with a <tt>cause</tt>.
       * @param argumentName The argument name used in the message.
       * @param argumentValue The argument value used in the message.
       * @param argumentFractionDigits The argument fraction digits used in the message.
       * @param maxFractionDigits The max fraction digits used in the message.
       * @param argumentClass The argument class used in the message.
    */
   public ArgumentFractionDigitsViolationException (String argumentName, Serializable argumentValue, Number argumentFractionDigits, Number maxFractionDigits, Class argumentClass)
   {
      super(RteLogMessage.ARGUMENT_FRACTION_DIGITS_VIOLATION);
      mArgumentName = argumentName;
      mArgumentValue = argumentValue;
      mArgumentFractionDigits = argumentFractionDigits;
      mMaxFractionDigits = maxFractionDigits;
      mArgumentClass = argumentClass;
      RteLogMessage.ArgumentFractionDigitsViolation.addParameters(this,
         argumentName, argumentValue, argumentFractionDigits, maxFractionDigits, argumentClass);
      logCreation();
   }

   /**
    * Constructor getting an log message info.
    * This constructor is for generated exceptions internal use only.
    *
    * @param messageInfo the log message info for this exception
    */
   protected ArgumentFractionDigitsViolationException (RteLogMessage messageInfo)
   {
      super(messageInfo);
      mArgumentName = null;
      mArgumentValue = null;
      mArgumentFractionDigits = null;
      mMaxFractionDigits = null;
      mArgumentClass = null;
      
   }

   /**
    * Constructor getting an log message info and a root exception.
    * This constructor is for generated exceptions internal use only.
    *
    * @param messageInfo the log message info for this exception
    * @param cause the problem that caused this exception to be thrown
    */
   protected ArgumentFractionDigitsViolationException (RteLogMessage messageInfo, Throwable cause)
   {
      super(messageInfo, cause);
      mArgumentName = null;
      mArgumentValue = null;
      mArgumentFractionDigits = null;
      mMaxFractionDigits = null;
      mArgumentClass = null;
      
   }

      
   /**
    * Returns the value of the parameter <tt>argumentName</tt>.
    * @return the value of the parameter <tt>argumentName</tt>.
    */
   public String valueOfArgumentName ()
   {
      return mArgumentName;
   }
      
   /**
    * Returns the value of the parameter <tt>argumentValue</tt>.
    * @return the value of the parameter <tt>argumentValue</tt>.
    */
   public Serializable valueOfArgumentValue ()
   {
      return mArgumentValue;
   }
      
   /**
    * Returns the value of the parameter <tt>argumentFractionDigits</tt>.
    * @return the value of the parameter <tt>argumentFractionDigits</tt>.
    */
   public Number valueOfArgumentFractionDigits ()
   {
      return mArgumentFractionDigits;
   }
      
   /**
    * Returns the value of the parameter <tt>maxFractionDigits</tt>.
    * @return the value of the parameter <tt>maxFractionDigits</tt>.
    */
   public Number valueOfMaxFractionDigits ()
   {
      return mMaxFractionDigits;
   }
      
   /**
    * Returns the value of the parameter <tt>argumentClass</tt>.
    * @return the value of the parameter <tt>argumentClass</tt>.
    */
   public Class valueOfArgumentClass ()
   {
      return mArgumentClass;
   }
      
}

