/*
 * Generated source file, not in CVS/SVN repository
 */
package org.jcoderz.commons;

import java.io.Serializable;

/**
 * 
 *
 * 
         The given argument is at least partly malformed.
         Argument ''{ARGUMENT_NAME}'' cannot be set to
         value ''{Serializable:ARGUMENT_VALUE}''. The length of the Value
         ({Integer:ARGUMENT_LENGTH}) exceeds the allowed maximum length
         ({Integer:MAX_LENGTH}) for {Class:ARGUMENT_CLASS}.
      
 *
 * This exception encapsulates the log message
 * {@link org.jcoderz.commons.RteLogMessage#ARGUMENT_MAX_LENGTH_VIOLATION}.
 *
 * @author generated
 */
public  class ArgumentMaxLengthViolationException
      extends org.jcoderz.commons.ArgumentMalformedException
{
   /** use this serialVersionUID for serialization. */
   static final long serialVersionUID = 1L;

   
   private final String mArgumentName;
      
   private final Serializable mArgumentValue;
      
   private final Integer mArgumentLength;
      
   private final Integer mMaxLength;
      
   private final Class mArgumentClass;
      

   /**
    * Constructs a argument max length violation exception with a <tt>cause</tt>.
       * @param argumentName The argument name used in the message.
       * @param argumentValue The argument value used in the message.
       * @param argumentLength The argument length used in the message.
       * @param maxLength The max length used in the message.
       * @param argumentClass The argument class used in the message.
    * @param cause the cause of this exception.
    */
   public ArgumentMaxLengthViolationException (String argumentName, Serializable argumentValue, Integer argumentLength, Integer maxLength, Class argumentClass, Throwable cause)
   {
      super(RteLogMessage.ARGUMENT_MAX_LENGTH_VIOLATION, cause);
      mArgumentName = argumentName;
      mArgumentValue = argumentValue;
      mArgumentLength = argumentLength;
      mMaxLength = maxLength;
      mArgumentClass = argumentClass;
      RteLogMessage.ArgumentMaxLengthViolation.addParameters(this,
         argumentName, argumentValue, argumentLength, maxLength, argumentClass);
      logCreation();
   }

   /**
    * Constructs a argument max length violation exception with a <tt>cause</tt>.
       * @param argumentName The argument name used in the message.
       * @param argumentValue The argument value used in the message.
       * @param argumentLength The argument length used in the message.
       * @param maxLength The max length used in the message.
       * @param argumentClass The argument class used in the message.
    */
   public ArgumentMaxLengthViolationException (String argumentName, Serializable argumentValue, Integer argumentLength, Integer maxLength, Class argumentClass)
   {
      super(RteLogMessage.ARGUMENT_MAX_LENGTH_VIOLATION);
      mArgumentName = argumentName;
      mArgumentValue = argumentValue;
      mArgumentLength = argumentLength;
      mMaxLength = maxLength;
      mArgumentClass = argumentClass;
      RteLogMessage.ArgumentMaxLengthViolation.addParameters(this,
         argumentName, argumentValue, argumentLength, maxLength, argumentClass);
      logCreation();
   }

   /**
    * Constructor getting an log message info.
    * This constructor is for generated exceptions internal use only.
    *
    * @param messageInfo the log message info for this exception
    */
   protected ArgumentMaxLengthViolationException (RteLogMessage messageInfo)
   {
      super(messageInfo);
      mArgumentName = null;
      mArgumentValue = null;
      mArgumentLength = null;
      mMaxLength = null;
      mArgumentClass = null;
      
   }

   /**
    * Constructor getting an log message info and a root exception.
    * This constructor is for generated exceptions internal use only.
    *
    * @param messageInfo the log message info for this exception
    * @param cause the problem that caused this exception to be thrown
    */
   protected ArgumentMaxLengthViolationException (RteLogMessage messageInfo, Throwable cause)
   {
      super(messageInfo, cause);
      mArgumentName = null;
      mArgumentValue = null;
      mArgumentLength = null;
      mMaxLength = null;
      mArgumentClass = null;
      
   }

      
   /**
    * Returns the value of the parameter <tt>argumentName</tt>.
    * @return the value of the parameter <tt>argumentName</tt>.
    */
   public String valueOfArgumentName ()
   {
      return mArgumentName;
   }
      
   /**
    * Returns the value of the parameter <tt>argumentValue</tt>.
    * @return the value of the parameter <tt>argumentValue</tt>.
    */
   public Serializable valueOfArgumentValue ()
   {
      return mArgumentValue;
   }
      
   /**
    * Returns the value of the parameter <tt>argumentLength</tt>.
    * @return the value of the parameter <tt>argumentLength</tt>.
    */
   public Integer valueOfArgumentLength ()
   {
      return mArgumentLength;
   }
      
   /**
    * Returns the value of the parameter <tt>maxLength</tt>.
    * @return the value of the parameter <tt>maxLength</tt>.
    */
   public Integer valueOfMaxLength ()
   {
      return mMaxLength;
   }
      
   /**
    * Returns the value of the parameter <tt>argumentClass</tt>.
    * @return the value of the parameter <tt>argumentClass</tt>.
    */
   public Class valueOfArgumentClass ()
   {
      return mArgumentClass;
   }
      
}

