/*
 * Generated source file, not in CVS/SVN repository
 */
package org.jcoderz.commons;

import java.io.Serializable;

/**
 * 
 *
 * 
         The given argument is at least partly malformed.
         Argument ''{ARGUMENT_NAME}'' cannot be set to
         value ''{Serializable:ARGUMENT_VALUE}''. The length of the Value
         ({Integer:ARGUMENT_LENGTH}) is below the allowed minimum length
         ({Integer:MIN_LENGTH}) for {Class:ARGUMENT_CLASS}.
      
 *
 * This exception encapsulates the log message
 * {@link org.jcoderz.commons.RteLogMessage#ARGUMENT_MIN_LENGTH_VIOLATION}.
 *
 * @author generated
 */
public  class ArgumentMinLengthViolationException
      extends org.jcoderz.commons.ArgumentMalformedException
{
   /** use this serialVersionUID for serialization. */
   static final long serialVersionUID = 1L;

   
   private final String mArgumentName;
      
   private final Serializable mArgumentValue;
      
   private final Integer mArgumentLength;
      
   private final Integer mMinLength;
      
   private final Class mArgumentClass;
      

   /**
    * Constructs a argument min length violation exception with a <tt>cause</tt>.
       * @param argumentName The argument name used in the message.
       * @param argumentValue The argument value used in the message.
       * @param argumentLength The argument length used in the message.
       * @param minLength The min length used in the message.
       * @param argumentClass The argument class used in the message.
    * @param cause the cause of this exception.
    */
   public ArgumentMinLengthViolationException (String argumentName, Serializable argumentValue, Integer argumentLength, Integer minLength, Class argumentClass, Throwable cause)
   {
      super(RteLogMessage.ARGUMENT_MIN_LENGTH_VIOLATION, cause);
      mArgumentName = argumentName;
      mArgumentValue = argumentValue;
      mArgumentLength = argumentLength;
      mMinLength = minLength;
      mArgumentClass = argumentClass;
      RteLogMessage.ArgumentMinLengthViolation.addParameters(this,
         argumentName, argumentValue, argumentLength, minLength, argumentClass);
      logCreation();
   }

   /**
    * Constructs a argument min length violation exception with a <tt>cause</tt>.
       * @param argumentName The argument name used in the message.
       * @param argumentValue The argument value used in the message.
       * @param argumentLength The argument length used in the message.
       * @param minLength The min length used in the message.
       * @param argumentClass The argument class used in the message.
    */
   public ArgumentMinLengthViolationException (String argumentName, Serializable argumentValue, Integer argumentLength, Integer minLength, Class argumentClass)
   {
      super(RteLogMessage.ARGUMENT_MIN_LENGTH_VIOLATION);
      mArgumentName = argumentName;
      mArgumentValue = argumentValue;
      mArgumentLength = argumentLength;
      mMinLength = minLength;
      mArgumentClass = argumentClass;
      RteLogMessage.ArgumentMinLengthViolation.addParameters(this,
         argumentName, argumentValue, argumentLength, minLength, argumentClass);
      logCreation();
   }

   /**
    * Constructor getting an log message info.
    * This constructor is for generated exceptions internal use only.
    *
    * @param messageInfo the log message info for this exception
    */
   protected ArgumentMinLengthViolationException (RteLogMessage messageInfo)
   {
      super(messageInfo);
      mArgumentName = null;
      mArgumentValue = null;
      mArgumentLength = null;
      mMinLength = null;
      mArgumentClass = null;
      
   }

   /**
    * Constructor getting an log message info and a root exception.
    * This constructor is for generated exceptions internal use only.
    *
    * @param messageInfo the log message info for this exception
    * @param cause the problem that caused this exception to be thrown
    */
   protected ArgumentMinLengthViolationException (RteLogMessage messageInfo, Throwable cause)
   {
      super(messageInfo, cause);
      mArgumentName = null;
      mArgumentValue = null;
      mArgumentLength = null;
      mMinLength = null;
      mArgumentClass = null;
      
   }

      
   /**
    * Returns the value of the parameter <tt>argumentName</tt>.
    * @return the value of the parameter <tt>argumentName</tt>.
    */
   public String valueOfArgumentName ()
   {
      return mArgumentName;
   }
      
   /**
    * Returns the value of the parameter <tt>argumentValue</tt>.
    * @return the value of the parameter <tt>argumentValue</tt>.
    */
   public Serializable valueOfArgumentValue ()
   {
      return mArgumentValue;
   }
      
   /**
    * Returns the value of the parameter <tt>argumentLength</tt>.
    * @return the value of the parameter <tt>argumentLength</tt>.
    */
   public Integer valueOfArgumentLength ()
   {
      return mArgumentLength;
   }
      
   /**
    * Returns the value of the parameter <tt>minLength</tt>.
    * @return the value of the parameter <tt>minLength</tt>.
    */
   public Integer valueOfMinLength ()
   {
      return mMinLength;
   }
      
   /**
    * Returns the value of the parameter <tt>argumentClass</tt>.
    * @return the value of the parameter <tt>argumentClass</tt>.
    */
   public Class valueOfArgumentClass ()
   {
      return mArgumentClass;
   }
      
}

