/*
 * Generated source file, not in CVS/SVN repository
 */
package org.jcoderz.commons;

import java.io.Serializable;

/**
 * 
 *
 * 
         The given argument is at least partly malformed.
         Argument ''{ARGUMENT_NAME}'' cannot be set to
         value ''{Serializable:ARGUMENT_VALUE}''. The value
         is below {Number:MIN_VALUE}, the allowed minimum
         for {Class:ARGUMENT_CLASS}.
      
 *
 * This exception encapsulates the log message
 * {@link org.jcoderz.commons.RteLogMessage#ARGUMENT_MIN_VALUE_VIOLATION}.
 *
 * @author generated
 */
public  class ArgumentMinValueViolationException
      extends org.jcoderz.commons.ArgumentMalformedException
{
   /** use this serialVersionUID for serialization. */
   static final long serialVersionUID = 1L;

   
   private final String mArgumentName;
      
   private final Serializable mArgumentValue;
      
   private final Number mMinValue;
      
   private final Class mArgumentClass;
      

   /**
    * Constructs a argument min value violation exception with a <tt>cause</tt>.
       * @param argumentName The argument name used in the message.
       * @param argumentValue The argument value used in the message.
       * @param minValue The min value used in the message.
       * @param argumentClass The argument class used in the message.
    * @param cause the cause of this exception.
    */
   public ArgumentMinValueViolationException (String argumentName, Serializable argumentValue, Number minValue, Class argumentClass, Throwable cause)
   {
      super(RteLogMessage.ARGUMENT_MIN_VALUE_VIOLATION, cause);
      mArgumentName = argumentName;
      mArgumentValue = argumentValue;
      mMinValue = minValue;
      mArgumentClass = argumentClass;
      RteLogMessage.ArgumentMinValueViolation.addParameters(this,
         argumentName, argumentValue, minValue, argumentClass);
      logCreation();
   }

   /**
    * Constructs a argument min value violation exception with a <tt>cause</tt>.
       * @param argumentName The argument name used in the message.
       * @param argumentValue The argument value used in the message.
       * @param minValue The min value used in the message.
       * @param argumentClass The argument class used in the message.
    */
   public ArgumentMinValueViolationException (String argumentName, Serializable argumentValue, Number minValue, Class argumentClass)
   {
      super(RteLogMessage.ARGUMENT_MIN_VALUE_VIOLATION);
      mArgumentName = argumentName;
      mArgumentValue = argumentValue;
      mMinValue = minValue;
      mArgumentClass = argumentClass;
      RteLogMessage.ArgumentMinValueViolation.addParameters(this,
         argumentName, argumentValue, minValue, argumentClass);
      logCreation();
   }

   /**
    * Constructor getting an log message info.
    * This constructor is for generated exceptions internal use only.
    *
    * @param messageInfo the log message info for this exception
    */
   protected ArgumentMinValueViolationException (RteLogMessage messageInfo)
   {
      super(messageInfo);
      mArgumentName = null;
      mArgumentValue = null;
      mMinValue = null;
      mArgumentClass = null;
      
   }

   /**
    * Constructor getting an log message info and a root exception.
    * This constructor is for generated exceptions internal use only.
    *
    * @param messageInfo the log message info for this exception
    * @param cause the problem that caused this exception to be thrown
    */
   protected ArgumentMinValueViolationException (RteLogMessage messageInfo, Throwable cause)
   {
      super(messageInfo, cause);
      mArgumentName = null;
      mArgumentValue = null;
      mMinValue = null;
      mArgumentClass = null;
      
   }

      
   /**
    * Returns the value of the parameter <tt>argumentName</tt>.
    * @return the value of the parameter <tt>argumentName</tt>.
    */
   public String valueOfArgumentName ()
   {
      return mArgumentName;
   }
      
   /**
    * Returns the value of the parameter <tt>argumentValue</tt>.
    * @return the value of the parameter <tt>argumentValue</tt>.
    */
   public Serializable valueOfArgumentValue ()
   {
      return mArgumentValue;
   }
      
   /**
    * Returns the value of the parameter <tt>minValue</tt>.
    * @return the value of the parameter <tt>minValue</tt>.
    */
   public Number valueOfMinValue ()
   {
      return mMinValue;
   }
      
   /**
    * Returns the value of the parameter <tt>argumentClass</tt>.
    * @return the value of the parameter <tt>argumentClass</tt>.
    */
   public Class valueOfArgumentClass ()
   {
      return mArgumentClass;
   }
      
}

