/*
 * Generated source file, not in CVS/SVN repository
 */
package org.jcoderz.commons;

import java.io.Serializable;

/**
 * 
 *
 * 
         The given argument is at least partly malformed.
         Argument ''{ARGUMENT_NAME}'' cannot be set to
         value ''{Serializable:ARGUMENT_VALUE}''. The value
         does not match the restrictive pattern
         ''{String:PATTERN}'' for {Class:ARGUMENT_CLASS}.
      
 *
 * This exception encapsulates the log message
 * {@link org.jcoderz.commons.RteLogMessage#ARGUMENT_PATTERN_VIOLATION}.
 *
 * @author generated
 */
public  class ArgumentPatternViolationException
      extends org.jcoderz.commons.ArgumentMalformedException
{
   /** use this serialVersionUID for serialization. */
   static final long serialVersionUID = 1L;

   
   private final String mArgumentName;
      
   private final Serializable mArgumentValue;
      
   private final String mPattern;
      
   private final Class mArgumentClass;
      

   /**
    * Constructs a argument pattern violation exception with a <tt>cause</tt>.
       * @param argumentName The argument name used in the message.
       * @param argumentValue The argument value used in the message.
       * @param pattern The pattern used in the message.
       * @param argumentClass The argument class used in the message.
    * @param cause the cause of this exception.
    */
   public ArgumentPatternViolationException (String argumentName, Serializable argumentValue, String pattern, Class argumentClass, Throwable cause)
   {
      super(RteLogMessage.ARGUMENT_PATTERN_VIOLATION, cause);
      mArgumentName = argumentName;
      mArgumentValue = argumentValue;
      mPattern = pattern;
      mArgumentClass = argumentClass;
      RteLogMessage.ArgumentPatternViolation.addParameters(this,
         argumentName, argumentValue, pattern, argumentClass);
      logCreation();
   }

   /**
    * Constructs a argument pattern violation exception with a <tt>cause</tt>.
       * @param argumentName The argument name used in the message.
       * @param argumentValue The argument value used in the message.
       * @param pattern The pattern used in the message.
       * @param argumentClass The argument class used in the message.
    */
   public ArgumentPatternViolationException (String argumentName, Serializable argumentValue, String pattern, Class argumentClass)
   {
      super(RteLogMessage.ARGUMENT_PATTERN_VIOLATION);
      mArgumentName = argumentName;
      mArgumentValue = argumentValue;
      mPattern = pattern;
      mArgumentClass = argumentClass;
      RteLogMessage.ArgumentPatternViolation.addParameters(this,
         argumentName, argumentValue, pattern, argumentClass);
      logCreation();
   }

   /**
    * Constructor getting an log message info.
    * This constructor is for generated exceptions internal use only.
    *
    * @param messageInfo the log message info for this exception
    */
   protected ArgumentPatternViolationException (RteLogMessage messageInfo)
   {
      super(messageInfo);
      mArgumentName = null;
      mArgumentValue = null;
      mPattern = null;
      mArgumentClass = null;
      
   }

   /**
    * Constructor getting an log message info and a root exception.
    * This constructor is for generated exceptions internal use only.
    *
    * @param messageInfo the log message info for this exception
    * @param cause the problem that caused this exception to be thrown
    */
   protected ArgumentPatternViolationException (RteLogMessage messageInfo, Throwable cause)
   {
      super(messageInfo, cause);
      mArgumentName = null;
      mArgumentValue = null;
      mPattern = null;
      mArgumentClass = null;
      
   }

      
   /**
    * Returns the value of the parameter <tt>argumentName</tt>.
    * @return the value of the parameter <tt>argumentName</tt>.
    */
   public String valueOfArgumentName ()
   {
      return mArgumentName;
   }
      
   /**
    * Returns the value of the parameter <tt>argumentValue</tt>.
    * @return the value of the parameter <tt>argumentValue</tt>.
    */
   public Serializable valueOfArgumentValue ()
   {
      return mArgumentValue;
   }
      
   /**
    * Returns the value of the parameter <tt>pattern</tt>.
    * @return the value of the parameter <tt>pattern</tt>.
    */
   public String valueOfPattern ()
   {
      return mPattern;
   }
      
   /**
    * Returns the value of the parameter <tt>argumentClass</tt>.
    * @return the value of the parameter <tt>argumentClass</tt>.
    */
   public Class valueOfArgumentClass ()
   {
      return mArgumentClass;
   }
      
}

