/*
 * Generated source file, not in CVS/SVN repository
 */
package org.jcoderz.commons;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;
import java.util.logging.Level;

import org.jcoderz.commons.LogMessageInfoImpl;
import org.jcoderz.commons.BusinessImpact;
import org.jcoderz.commons.Category;
import org.jcoderz.commons.LogEvent;
import org.jcoderz.commons.AuditLogEvent;
import org.jcoderz.commons.Loggable;
import org.jcoderz.commons.AuditPrincipal;

/**
 * Enumeration of all Common Error log messages.
 *
 * <p>Instances of this class are immutable.</p>
 *
 * The following Common Error are defined:
 * <ul>
 *    <li>CmnLogMessage.ENTITY_NOT_FOUND</li>
 * </ul>
 *
 * @author generated
 */
public abstract class CmnLogMessage
      extends LogMessageInfoImpl
{
   /** use this serialVersionUID for serialization. */
   static final long serialVersionUID = 1L;

   /**
    * Private constructor used by the inner classes.
    * @param symbol The symbolic name of the log message.
    * @param id The unique numeric id of the log message.
    * @param level The log level that is used to log such a message.
    * @param text The detailed text of the log message.
    * @param solution The solution text of the log message.
    * @param businessImpact The business impact of the log message.
    * @param category The category of the log message.
    * @param params The paramter list used in the detailed text.
    * @param appName The application name.
    * @param appNameAbbr The application name abbreviation.
    * @param groupName The group name.
    * @param groupNameAbbr The group name abbreviation.
    */
   private CmnLogMessage (String symbol, int id, Level level,
         String text, String solution, BusinessImpact businessImpact,
         Category category, String[] params, String appName, String appNameAbbr,
         String groupName, String groupNameAbbr)
   {
      super(symbol, id, level, text, solution, businessImpact, category, params,
            appName, appNameAbbr, groupName, groupNameAbbr);
   }

   /**
    A database entry in table {TABLE} was not found. No rows were returned when executing the finder method ''{FINDER}'' with the argument(s) ''{Serializable:ARGUMENTS}'' on entity bean {ENTITY}.
    * .
    * <p>This class holds the static data for the <code>ENTITY_NOT_FOUND</code>
    * log message.</p>
    * <p>It holds the following parameters:</p>
    * <ul>
    * 
       <li>Message: A database entry in table {TABLE} was not found. No rows were returned when executing the finder method ''{FINDER}'' with the argument(s) ''{Serializable:ARGUMENTS}'' on entity bean {ENTITY}.</li>
      
       <li>Solution Review the log file to determine if the usage of the Administration Tool led to the error. Create the requested value prior to using the Administration Tool or change the query used for retrieving the value via the Adminstration Tool.</li>
      
    * </ul>
    */
   public static final class EntityNotFound
         extends CmnLogMessage
         implements Serializable
   {  
      /** The unique integer value of the log message <code>ENTITY_NOT_FOUND</code>. */
      public static final int INT_VALUE = 16908289;
   
      /** The parameter <code>TABLE</code> for the log message text. */
      public static final String PARAM_TABLE
            = "TABLE";
      
      /** The parameter <code>FINDER</code> for the log message text. */
      public static final String PARAM_FINDER
            = "FINDER";
      
      /** The parameter <code>ARGUMENTS</code> for the log message text. */
      public static final String PARAM_ARGUMENTS
            = "ARGUMENTS";
      
      /** The parameter <code>ENTITY</code> for the log message text. */
      public static final String PARAM_ENTITY
            = "ENTITY";
      

      /**
       * The unique symbolic String of the log message
       * <code>ENTITY_NOT_FOUND</code>.
    
    
       * @description A database entry in table {TABLE} was not found. No rows were returned when executing the finder method ''{FINDER}'' with the argument(s) ''{Serializable:ARGUMENTS}'' on entity bean {ENTITY}.
       * @solution Review the log file to determine if the usage of the Administration Tool led to the error. Create the requested value prior to using the Administration Tool or change the query used for retrieving the value via the Adminstration Tool.
       */
      public static final String SYMBOL
        = "FWK_CMN_ENTITY_NOT_FOUND";

      /** The LogLevel to use. */
      public static final Level LOG_LEVEL
        = 
            Level.SEVERE;

      /** The serialVersionUID used for serialization. */
      static final long serialVersionUID = 1;

      /**
       * Constructor.
       */
      private EntityNotFound ()
      {
         // Do not access static members of this class here in the
         // constructor!
         // They might be not initialized (if the outer class
         // static constant is used to access the object ex.
         // FOO_MESSAGE.log()
         super(
               "FWK_CMN_ENTITY_NOT_FOUND",
               16908289,
               
            Level.SEVERE,
               "A database entry in table {0} was not found. No rows were returned when executing the finder method ''{1}'' with the argument(s) ''{2}'' on entity bean {3}.",
               "Review the log file to determine if the usage of the Administration Tool led to the error. Create the requested value prior to using the Administration Tool or change the query used for retrieving the value via the Adminstration Tool.",
               BusinessImpact.UNDEFINED,
               Category.UNDEFINED,
               new String[]
                  {
                     "TABLE" ,  // PARAM_TABLE
                     "FINDER" ,  // PARAM_FINDER
                     "ARGUMENTS" ,  // PARAM_ARGUMENTS
                     "ENTITY"   // PARAM_ENTITY
                  },
               "FawkeZ",
               "FWK",
               "Common Error",
               "CMN");
      }
      

      /**
       * Adds the given message parameters to the <tt>loggable</tt>.
       * @param loggable the loggable to initialize. 
       * @param table The table used in the message.
       * @param finder The finder used in the message.
       * @param arguments The arguments used in the message.
       * @param entity The entity used in the message.
       * @return the given initialized <tt>loggable</tt>.
       */
      public static Loggable addParameters (Loggable loggable, String table, String finder, Serializable arguments, String entity)
      {
         loggable.addParameter(PARAM_TABLE, table);
         loggable.addParameter(PARAM_FINDER, finder);
         loggable.addParameter(PARAM_ARGUMENTS, arguments);
         loggable.addParameter(PARAM_ENTITY, entity);
         return loggable;
      }

      private Object readResolve ()
      {
         return fromInt(INT_VALUE);
      }

   }

   /** The log message for the event <code>ENTITY_NOT_FOUND</code>. */
   public static final EntityNotFound ENTITY_NOT_FOUND
         = new EntityNotFound();


   private static final Map FROM_INT_MAP = new HashMap();
   private static final Map FROM_STRING_MAP = new HashMap();

   static
   {  
      addToMaps(ENTITY_NOT_FOUND);
   }

   private static final void addToMaps (CmnLogMessage error)
   {
      FROM_INT_MAP.put(new Integer(error.toInt()), error);
      FROM_STRING_MAP.put(error.toString(), error);
   }

   /**
    * Factory method to create a CmnLogMessage class from its
    * string representation.
    * @param value the string representation.
    * @return CmnLogMessage class from its string representation.
    */
   public static final CmnLogMessage fromString (String value)
   {
      final CmnLogMessage result
            = (CmnLogMessage) FROM_STRING_MAP.get(value);
      if (result == null)
      {
         throw new IllegalArgumentException(
               value + " is not a valid string "
               + "representation for CmnLogMessage");
      }
      return result;
   }

   /**
    * Factory method to create a CmnLogMessage class from its
    * integer representation.
    * @param value the integer representation.
    * @return CmnLogMessage class from its integer representation.
    */
   public static final CmnLogMessage fromInt (int value)
   {
      final CmnLogMessage result
            = (CmnLogMessage) FROM_INT_MAP.get(new Integer(value));
      if (result == null)
      {
         throw new IllegalArgumentException(
               value + " is not a valid int "
               + "representation for CmnLogMessage");
      }
      return result;
   }
}

