/*
 * Generated source file, not in CVS/SVN repository
 */
package org.jcoderz.commons;

import java.io.Serializable;

/**
 * 
 *
 * 
         While accessing table {TABLE}, the following problem was
         encountered: {PROBLEM}.
      
 *
 * This exception encapsulates the log message
 * {@link org.jcoderz.commons.RteLogMessage#DATABASE_INTEGRITY_ERROR}.
 *
 * @author generated
 */
public  class DatabaseIntegrityErrorException
      extends org.jcoderz.commons.InconsistentDatabaseException
{
   /** use this serialVersionUID for serialization. */
   static final long serialVersionUID = 1L;

   
   private final String mTable;
      
   private final String mProblem;
      

   /**
    * Constructs a database integrity error exception with a <tt>cause</tt>.
       * @param table The table used in the message.
       * @param problem The problem used in the message.
    * @param cause the cause of this exception.
    */
   public DatabaseIntegrityErrorException (String table, String problem, Throwable cause)
   {
      super(RteLogMessage.DATABASE_INTEGRITY_ERROR, cause);
      mTable = table;
      mProblem = problem;
      RteLogMessage.DatabaseIntegrityError.addParameters(this,
         table, problem);
      logCreation();
   }

   /**
    * Constructs a database integrity error exception with a <tt>cause</tt>.
       * @param table The table used in the message.
       * @param problem The problem used in the message.
    */
   public DatabaseIntegrityErrorException (String table, String problem)
   {
      super(RteLogMessage.DATABASE_INTEGRITY_ERROR);
      mTable = table;
      mProblem = problem;
      RteLogMessage.DatabaseIntegrityError.addParameters(this,
         table, problem);
      logCreation();
   }

   /**
    * Constructor getting an log message info.
    * This constructor is for generated exceptions internal use only.
    *
    * @param messageInfo the log message info for this exception
    */
   protected DatabaseIntegrityErrorException (RteLogMessage messageInfo)
   {
      super(messageInfo);
      mTable = null;
      mProblem = null;
      
   }

   /**
    * Constructor getting an log message info and a root exception.
    * This constructor is for generated exceptions internal use only.
    *
    * @param messageInfo the log message info for this exception
    * @param cause the problem that caused this exception to be thrown
    */
   protected DatabaseIntegrityErrorException (RteLogMessage messageInfo, Throwable cause)
   {
      super(messageInfo, cause);
      mTable = null;
      mProblem = null;
      
   }

      
   /**
    * Returns the value of the parameter <tt>table</tt>.
    * @return the value of the parameter <tt>table</tt>.
    */
   public String valueOfTable ()
   {
      return mTable;
   }
      
   /**
    * Returns the value of the parameter <tt>problem</tt>.
    * @return the value of the parameter <tt>problem</tt>.
    */
   public String valueOfProblem ()
   {
      return mProblem;
   }
      
}

