/*
 * Generated source file, not in CVS/SVN repository
 */
package org.jcoderz.commons;

import java.io.Serializable;

/**
 * 
 *
 * 
         A database entry in table {TABLE} was not found.
         No rows were returned when executing the
         finder method ''{FINDER}'' with the argument(s)
         ''{Serializable:ARGUMENTS}'' on entity bean {ENTITY}.
      
 *
 * This exception encapsulates the log message
 * {@link org.jcoderz.commons.CmnLogMessage#ENTITY_NOT_FOUND}.
 *
 * @author generated
 */
public  class EntityNotFoundException
      extends org.jcoderz.commons.BaseException
{
   /** use this serialVersionUID for serialization. */
   static final long serialVersionUID = 1L;

   
   private final String mTable;
      
   private final String mFinder;
      
   private final Serializable mArguments;
      
   private final String mEntity;
      

   /**
    * Constructs a entity not found exception with a <tt>cause</tt>.
       * @param table The table used in the message.
       * @param finder The finder used in the message.
       * @param arguments The arguments used in the message.
       * @param entity The entity used in the message.
    * @param cause the cause of this exception.
    */
   public EntityNotFoundException (String table, String finder, Serializable arguments, String entity, Throwable cause)
   {
      super(CmnLogMessage.ENTITY_NOT_FOUND, cause);
      mTable = table;
      mFinder = finder;
      mArguments = arguments;
      mEntity = entity;
      CmnLogMessage.EntityNotFound.addParameters(this,
         table, finder, arguments, entity);
      logCreation();
   }

   /**
    * Constructs a entity not found exception with a <tt>cause</tt>.
       * @param table The table used in the message.
       * @param finder The finder used in the message.
       * @param arguments The arguments used in the message.
       * @param entity The entity used in the message.
    */
   public EntityNotFoundException (String table, String finder, Serializable arguments, String entity)
   {
      super(CmnLogMessage.ENTITY_NOT_FOUND);
      mTable = table;
      mFinder = finder;
      mArguments = arguments;
      mEntity = entity;
      CmnLogMessage.EntityNotFound.addParameters(this,
         table, finder, arguments, entity);
      logCreation();
   }

   /**
    * Constructor getting an log message info.
    * This constructor is for generated exceptions internal use only.
    *
    * @param messageInfo the log message info for this exception
    */
   protected EntityNotFoundException (CmnLogMessage messageInfo)
   {
      super(messageInfo);
      mTable = null;
      mFinder = null;
      mArguments = null;
      mEntity = null;
      
   }

   /**
    * Constructor getting an log message info and a root exception.
    * This constructor is for generated exceptions internal use only.
    *
    * @param messageInfo the log message info for this exception
    * @param cause the problem that caused this exception to be thrown
    */
   protected EntityNotFoundException (CmnLogMessage messageInfo, Throwable cause)
   {
      super(messageInfo, cause);
      mTable = null;
      mFinder = null;
      mArguments = null;
      mEntity = null;
      
   }

      
   /**
    * Returns the value of the parameter <tt>table</tt>.
    * @return the value of the parameter <tt>table</tt>.
    */
   public String valueOfTable ()
   {
      return mTable;
   }
      
   /**
    * Returns the value of the parameter <tt>finder</tt>.
    * @return the value of the parameter <tt>finder</tt>.
    */
   public String valueOfFinder ()
   {
      return mFinder;
   }
      
   /**
    * Returns the value of the parameter <tt>arguments</tt>.
    * @return the value of the parameter <tt>arguments</tt>.
    */
   public Serializable valueOfArguments ()
   {
      return mArguments;
   }
      
   /**
    * Returns the value of the parameter <tt>entity</tt>.
    * @return the value of the parameter <tt>entity</tt>.
    */
   public String valueOfEntity ()
   {
      return mEntity;
   }
      
}

