/*
 * Generated source file, not in CVS/SVN repository
 */
package org.jcoderz.commons;

import java.io.Serializable;

/**
 * 
 *
 * 
         A value read from the database was invalid.
         The database value {Serializable:ARGUMENT_VALUE} of column
         {COLUMN} in table {TABLE} could not be converted into
         the java type {TYPE}. Possibly the database has been
         modified manually, or the software that wrote the database
         contains a bug.
      
 *
 * This exception encapsulates the log message
 * {@link org.jcoderz.commons.RteLogMessage#INCONSISTENT_DATABASE}.
 *
 * @author generated
 */
public  class InconsistentDatabaseException
      extends org.jcoderz.commons.BaseRuntimeException
{
   /** use this serialVersionUID for serialization. */
   static final long serialVersionUID = 1L;

   
   private final Serializable mArgumentValue;
      
   private final String mColumn;
      
   private final String mTable;
      
   private final String mType;
      

   /**
    * Constructs a inconsistent database exception with a <tt>cause</tt>.
       * @param argumentValue The argument value used in the message.
       * @param column The column used in the message.
       * @param table The table used in the message.
       * @param type The type used in the message.
    * @param cause the cause of this exception.
    */
   public InconsistentDatabaseException (Serializable argumentValue, String column, String table, String type, Throwable cause)
   {
      super(RteLogMessage.INCONSISTENT_DATABASE, cause);
      mArgumentValue = argumentValue;
      mColumn = column;
      mTable = table;
      mType = type;
      RteLogMessage.InconsistentDatabase.addParameters(this,
         argumentValue, column, table, type);
      logCreation();
   }

   /**
    * Constructs a inconsistent database exception with a <tt>cause</tt>.
       * @param argumentValue The argument value used in the message.
       * @param column The column used in the message.
       * @param table The table used in the message.
       * @param type The type used in the message.
    */
   public InconsistentDatabaseException (Serializable argumentValue, String column, String table, String type)
   {
      super(RteLogMessage.INCONSISTENT_DATABASE);
      mArgumentValue = argumentValue;
      mColumn = column;
      mTable = table;
      mType = type;
      RteLogMessage.InconsistentDatabase.addParameters(this,
         argumentValue, column, table, type);
      logCreation();
   }

   /**
    * Constructor getting an log message info.
    * This constructor is for generated exceptions internal use only.
    *
    * @param messageInfo the log message info for this exception
    */
   protected InconsistentDatabaseException (RteLogMessage messageInfo)
   {
      super(messageInfo);
      mArgumentValue = null;
      mColumn = null;
      mTable = null;
      mType = null;
      
   }

   /**
    * Constructor getting an log message info and a root exception.
    * This constructor is for generated exceptions internal use only.
    *
    * @param messageInfo the log message info for this exception
    * @param cause the problem that caused this exception to be thrown
    */
   protected InconsistentDatabaseException (RteLogMessage messageInfo, Throwable cause)
   {
      super(messageInfo, cause);
      mArgumentValue = null;
      mColumn = null;
      mTable = null;
      mType = null;
      
   }

      
   /**
    * Returns the value of the parameter <tt>argumentValue</tt>.
    * @return the value of the parameter <tt>argumentValue</tt>.
    */
   public Serializable valueOfArgumentValue ()
   {
      return mArgumentValue;
   }
      
   /**
    * Returns the value of the parameter <tt>column</tt>.
    * @return the value of the parameter <tt>column</tt>.
    */
   public String valueOfColumn ()
   {
      return mColumn;
   }
      
   /**
    * Returns the value of the parameter <tt>table</tt>.
    * @return the value of the parameter <tt>table</tt>.
    */
   public String valueOfTable ()
   {
      return mTable;
   }
      
   /**
    * Returns the value of the parameter <tt>type</tt>.
    * @return the value of the parameter <tt>type</tt>.
    */
   public String valueOfType ()
   {
      return mType;
   }
      
}

