/*
 * Generated source file, not in CVS/SVN repository
 */
package org.jcoderz.commons;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;
import java.util.logging.Level;

import org.jcoderz.commons.LogMessageInfoImpl;
import org.jcoderz.commons.BusinessImpact;
import org.jcoderz.commons.Category;
import org.jcoderz.commons.LogEvent;
import org.jcoderz.commons.AuditLogEvent;
import org.jcoderz.commons.Loggable;
import org.jcoderz.commons.AuditPrincipal;

/**
 * Enumeration of all Test Messages log messages.
 *
 * <p>Instances of this class are immutable.</p>
 *
 * The following Test Messages are defined:
 * <ul>
 *    <li>TstLogMessage.TEST_MESSAGE</li>
 *    <li>TstLogMessage.TEST_AUDIT_MESSAGE</li>
 * </ul>
 *
 * @author generated
 */
public abstract class TstLogMessage
      extends LogMessageInfoImpl
{
   /** use this serialVersionUID for serialization. */
   static final long serialVersionUID = 1L;

   /**
    * Private constructor used by the inner classes.
    * @param symbol The symbolic name of the log message.
    * @param id The unique numeric id of the log message.
    * @param level The log level that is used to log such a message.
    * @param text The detailed text of the log message.
    * @param solution The solution text of the log message.
    * @param businessImpact The business impact of the log message.
    * @param category The category of the log message.
    * @param params The paramter list used in the detailed text.
    * @param appName The application name.
    * @param appNameAbbr The application name abbreviation.
    * @param groupName The group name.
    * @param groupNameAbbr The group name abbreviation.
    */
   private TstLogMessage (String symbol, int id, Level level,
         String text, String solution, BusinessImpact businessImpact,
         Category category, String[] params, String appName, String appNameAbbr,
         String groupName, String groupNameAbbr)
   {
      super(symbol, id, level, text, solution, businessImpact, category, params,
            appName, appNameAbbr, groupName, groupNameAbbr);
   }

   /**
    This is a test message and should not be used in a production environment. The parameter foo is set to ''{FOO}''. Now it''s {java.util.Date:NOW,date}. Time {java.util.Date:NOW,time}.
    * .
    * <p>This class holds the static data for the <code>TEST_MESSAGE</code>
    * log message.</p>
    * <p>It holds the following parameters:</p>
    * <ul>
    * 
       <li>Message: This is a test message and should not be used in a production environment. The parameter foo is set to ''{FOO}''. Now it''s {java.util.Date:NOW,date}. Time {java.util.Date:NOW,time}.</li>
      
       <li>Solution This is the solution of the test message.</li>
      
    * </ul>
    */
   public static final class TestMessage
         extends TstLogMessage
         implements Serializable
   {  
      /** The unique integer value of the log message <code>TEST_MESSAGE</code>. */
      public static final int INT_VALUE = 33554432;
   
      /** The parameter <code>FOO</code> for the log message text. */
      public static final String PARAM_FOO
            = "FOO";
      
      /** The parameter <code>NOW</code> for the log message text. */
      public static final String PARAM_NOW
            = "NOW";
      

      /**
       * The unique symbolic String of the log message
       * <code>TEST_MESSAGE</code>.
    
    
       * @description This is a test message and should not be used in a production environment. The parameter foo is set to ''{FOO}''. Now it''s {java.util.Date:NOW,date}. Time {java.util.Date:NOW,time}.
       * @solution This is the solution of the test message.
       */
      public static final String SYMBOL
        = "FWK_TST_TEST_MESSAGE";

      /** The LogLevel to use. */
      public static final Level LOG_LEVEL
        = java.util.logging.Level.INFO;

      /** The serialVersionUID used for serialization. */
      static final long serialVersionUID = 1;

      /**
       * Constructor.
       */
      private TestMessage ()
      {
         // Do not access static members of this class here in the
         // constructor!
         // They might be not initialized (if the outer class
         // static constant is used to access the object ex.
         // FOO_MESSAGE.log()
         super(
               "FWK_TST_TEST_MESSAGE",
               33554432,
               java.util.logging.Level.INFO,
               "This is a test message and should not be used in a production environment. The parameter foo is set to ''{0}''. Now it''s {1,date}. Time {1,time}.",
               "This is the solution of the test message.",
               BusinessImpact.UNDEFINED,
               Category.UNDEFINED,
               new String[]
                  {
                     "FOO" ,  // PARAM_FOO
                     "NOW"   // PARAM_NOW
                  },
               "FawkeZ",
               "FWK",
               "Test Messages",
               "TST");
      }
      
      /**
       * Logs the message
       * <tt>"This is a test message and should not be used in a production environment. The parameter foo is set to ''{FOO}''. Now it''s {java.util.Date:NOW,date}. Time {java.util.Date:NOW,time}."</tt>
       * with the given parameters.
       * @param foo The foo used in the message.
       * @param now The now used in the message.
       */
      public static void log (String foo, java.util.Date now
            )
      { 
         addParameters(new LogEvent(TEST_MESSAGE)
               , foo, now).log();
      }

      /**
       * Logs the message
       * <tt>"This is a test message and should not be used in a production environment. The parameter foo is set to ''{FOO}''. Now it''s {java.util.Date:NOW,date}. Time {java.util.Date:NOW,time}."</tt>
       * with the given parameters.
       * @param foo The foo used in the message.
       * @param now The now used in the message.
       * @param cause the Throwable that causes this message to be logged.
       */
      public static void log (String foo, java.util.Date now, Throwable cause
            )
      {
         addParameters(new LogEvent(TEST_MESSAGE, cause), foo, now).log();
      }
        

      /**
       * Adds the given message parameters to the <tt>loggable</tt>.
       * @param loggable the loggable to initialize. 
       * @param foo The foo used in the message.
       * @param now The now used in the message.
       * @return the given initialized <tt>loggable</tt>.
       */
      public static Loggable addParameters (Loggable loggable, String foo, java.util.Date now)
      {
         loggable.addParameter(PARAM_FOO, foo);
         loggable.addParameter(PARAM_NOW, now);
         return loggable;
      }

      private Object readResolve ()
      {
         return fromInt(INT_VALUE);
      }

   }

   /**
    This is a test audit event and should not be used in a production environment.
    * .
    * <p>This class holds the static data for the <code>TEST_AUDIT_MESSAGE</code>
    * log message.</p>
    * <p>It holds the following parameters:</p>
    * <ul>
    * 
       <li>Message: This is a test audit event and should not be used in a production environment.</li>
      
    * </ul>
    */
   public static final class TestAuditMessage
         extends TstLogMessage
         implements Serializable
   {  
      /** The unique integer value of the log message <code>TEST_AUDIT_MESSAGE</code>. */
      public static final int INT_VALUE = 33554431;
   

      /**
       * The unique symbolic String of the log message
       * <code>TEST_AUDIT_MESSAGE</code>.
    
    
       * @description This is a test audit event and should not be used in a production environment.
       */
      public static final String SYMBOL
        = "FWK_TST_TEST_AUDIT_MESSAGE";

      /** The LogLevel to use. */
      public static final Level LOG_LEVEL
        = 
            Level.INFO;

      /** The serialVersionUID used for serialization. */
      static final long serialVersionUID = 1;

      /**
       * Constructor.
       */
      private TestAuditMessage ()
      {
         // Do not access static members of this class here in the
         // constructor!
         // They might be not initialized (if the outer class
         // static constant is used to access the object ex.
         // FOO_MESSAGE.log()
         super(
               "FWK_TST_TEST_AUDIT_MESSAGE",
               33554431,
               
            Level.INFO,
               "This is a test audit event and should not be used in a production environment.",
               "",
               BusinessImpact.UNDEFINED,
               Category.AUDIT,
               new String[]
                  {
                  },
               "FawkeZ",
               "FWK",
               "Test Messages",
               "TST");
      }
      
      /**
       * Logs the message
       * <tt>"This is a test audit event and should not be used in a production environment."</tt>
       * with the given parameters.
       * @param auditPrincipal The audit principal that causes this
       *      log event.
   
       */
      public static void log (
      AuditPrincipal auditPrincipal
            )
      { 
         new AuditLogEvent(TEST_AUDIT_MESSAGE, auditPrincipal).log();
      }

      /**
       * Logs the message
       * <tt>"This is a test audit event and should not be used in a production environment."</tt>
       * with the given parameters.
       * @param auditPrincipal The audit principal that causes this
       *      log event.
   
       * @param cause the Throwable that causes this message to be logged.
       */
      public static void log (
      AuditPrincipal auditPrincipal, Throwable cause
            )
      {
         new AuditLogEvent(TEST_AUDIT_MESSAGE, auditPrincipal, cause).log();
      }
        
      /**
       * Creates the audit log event
       * <tt>"This is a test audit event and should not be used in a production environment."</tt>
       * with the given parameters.
       * @param auditPrincipal The audit principal that causes this
       *      log event.
   
       */
      public static AuditLogEvent create (
      AuditPrincipal auditPrincipal
            )
      { 
         return new AuditLogEvent(TEST_AUDIT_MESSAGE, auditPrincipal);
      }

      /**
       * Creates the audit log event
       * <tt>"This is a test audit event and should not be used in a production environment."</tt>
       * with the given parameters.
       * @param auditPrincipal The audit principal that causes this
       *      log event.
   
       * @param cause the Throwable that causes this message to be logged.
       */
      public static AuditLogEvent create (
      AuditPrincipal auditPrincipal,
               Throwable cause
            )
      {
         return new AuditLogEvent(TEST_AUDIT_MESSAGE, auditPrincipal, cause);
      }
      

      /**
       * Adds the given message parameters to the <tt>loggable</tt>.
       * @param loggable the loggable to initialize. 
       * @return the given initialized <tt>loggable</tt>.
       */
      public static Loggable addParameters (Loggable loggable)
      {
         return loggable;
      }

      private Object readResolve ()
      {
         return fromInt(INT_VALUE);
      }

   }

   /** The log message for the event <code>TEST_MESSAGE</code>. */
   public static final TestMessage TEST_MESSAGE
         = new TestMessage();

   /** The log message for the event <code>TEST_AUDIT_MESSAGE</code>. */
   public static final TestAuditMessage TEST_AUDIT_MESSAGE
         = new TestAuditMessage();


   private static final Map FROM_INT_MAP = new HashMap();
   private static final Map FROM_STRING_MAP = new HashMap();

   static
   {  
      addToMaps(TEST_MESSAGE);
      addToMaps(TEST_AUDIT_MESSAGE);
   }

   private static final void addToMaps (TstLogMessage error)
   {
      FROM_INT_MAP.put(new Integer(error.toInt()), error);
      FROM_STRING_MAP.put(error.toString(), error);
   }

   /**
    * Factory method to create a TstLogMessage class from its
    * string representation.
    * @param value the string representation.
    * @return TstLogMessage class from its string representation.
    */
   public static final TstLogMessage fromString (String value)
   {
      final TstLogMessage result
            = (TstLogMessage) FROM_STRING_MAP.get(value);
      if (result == null)
      {
         throw new IllegalArgumentException(
               value + " is not a valid string "
               + "representation for TstLogMessage");
      }
      return result;
   }

   /**
    * Factory method to create a TstLogMessage class from its
    * integer representation.
    * @param value the integer representation.
    * @return TstLogMessage class from its integer representation.
    */
   public static final TstLogMessage fromInt (int value)
   {
      final TstLogMessage result
            = (TstLogMessage) FROM_INT_MAP.get(new Integer(value));
      if (result == null)
      {
         throw new IllegalArgumentException(
               value + " is not a valid int "
               + "representation for TstLogMessage");
      }
      return result;
   }
}

