/*
 * Generated source file, not in CVS/SVN repository
 */
package org.jcoderz.commons.test;

import java.io.Serializable;

import org.jcoderz.commons.util.HashCodeUtil;

import org.jcoderz.commons.ArgumentMalformedException;
import org.jcoderz.commons.ArgumentMinValueViolationException;
import org.jcoderz.commons.ArgumentMaxValueViolationException;
import org.jcoderz.commons.util.RandomUtil;
import org.jcoderz.commons.util.Assert;


/**
 * Holds the RestrictedLong.
 * <pre>
 * long[15..255].
 * </pre>
 * Instances of this class are immutable.
 *
 * <p>This class implements the Comparable interface based on the numeric
 * order of its instances.</p>
 *
 * @author generated via stylesheet
 */
public final class RestrictedLong
      implements Serializable, org.jcoderz.commons.RestrictedLong, Comparable
{
   /**
    * RestrictedLong - the name of this type as string constant.
    */
   public static final String TYPE_NAME = "RestrictedLong";

   /**
    * The minimum value of a RestrictedLong (15).
    */
   public static final long MIN_VALUE = 15;

   /**
    * The maximum value of a RestrictedLong (255).
    */
   public static final long MAX_VALUE = 255;


   /** The serialVersionUID used for serialization. */
   static final long serialVersionUID = 1;

   /** Holds the RestrictedLong. */
   private final long mRestrictedLong;
   /** Lazy initialized long object value. */
   private transient Long mRestrictedLongLongObject;
   /** Lazy initialized hash code value. */
   private transient int mHashCode = 0;

   /**
    * Creates a new instance of a RestrictedLong.
    *
    * @param id the RestrictedLong as long representation
    * @throws ArgumentMalformedException If the given long <code>id</code>
    *         violates the restriction of the type
    *         RestrictedLong.
    * @throws ArgumentMinValueViolationException If the value of the given
    *         long <code>id</code> is below {@link #MIN_VALUE}.
    * @throws ArgumentMaxValueViolationException If the value of the given
    *         long <code>id</code> is above {@link #MAX_VALUE}.
    */
   private RestrictedLong (long id)
   {
      if (id < MIN_VALUE)
      {
         throw new ArgumentMinValueViolationException(
               TYPE_NAME, new Long(id), new Long(MIN_VALUE),
               RestrictedLong.class);
      }
      if (id > MAX_VALUE)
      {
         throw new ArgumentMaxValueViolationException(
               TYPE_NAME, new Long(id), new Long(MAX_VALUE),
               RestrictedLong.class);
      }
      mRestrictedLong = id;
   }

   /**
    * Construct a RestrictedLong object from its long representation.
    * @param id the long representation of the RestrictedLong
    * @return the RestrictedLong object represented by the given long
    * @throws ArgumentMalformedException If the given long <code>id</code>
    *         violates the restriction of the type
    *         RestrictedLong.
    * @throws ArgumentMinValueViolationException If the value of the given
    *         long <code>id</code> is below {@link #MIN_VALUE}.
    * @throws ArgumentMaxValueViolationException If the value of the given
    *         long <code>id</code> is above {@link #MAX_VALUE}.
    */
   public static RestrictedLong fromLong (long id)
         throws ArgumentMalformedException
   {
      return new RestrictedLong(id);
   }

   /**
    * Construct a RestrictedLong object from its string representation.
    * @param s the string representation of the RestrictedLong
    * @return the RestrictedLong object represented by the given string
    * @throws ArgumentMalformedException If the given string <code>s</code>
    *         violates the restriction of the type
    *         RestrictedLong.
    * @throws ArgumentMinValueViolationException If the value of the given
    *         long <code>id</code> is below {@link #MIN_VALUE}.
    * @throws ArgumentMaxValueViolationException If the value of the given
    *         long <code>id</code> is above {@link #MAX_VALUE}.
    */
   public static RestrictedLong fromString (String s)
         throws ArgumentMalformedException
   {
      final long id;
      try
      {
         id = Long.parseLong(s);
      }
      catch (NumberFormatException e)
      {
         throw new ArgumentMalformedException(
               TYPE_NAME, s, "Invalid string representation", e);
      }
      return new RestrictedLong(id);
   }

   /**
    * Construct a RestrictedLong object from its Long representation.
    * @param id the Long representation of the RestrictedLong
    * @return the RestrictedLong object represented by the given Long
    * @throws ArgumentMalformedException If the given Long <code>id</code>
    *         is null or violates the restriction of the type
    *         RestrictedLong.
    * @throws ArgumentMinValueViolationException If the value of the given
    *         long <code>id</code> is below {@link #MIN_VALUE}.
    * @throws ArgumentMaxValueViolationException If the value of the given
    *         long <code>id</code> is above {@link #MAX_VALUE}.
    */
   public static RestrictedLong fromLong (Long id)
         throws ArgumentMalformedException
   {
      Assert.notNull(id, "id");
      return new RestrictedLong(id.longValue());
   }

   /**
    * Generates a random RestrictedLong object.
    * @return a random RestrictedLong object.
    */
   public static RestrictedLong random ()
   {
      return new RestrictedLong(RandomUtil.random(MIN_VALUE, MAX_VALUE));
   }

   /**
    * Returns the long representation of this RestrictedLong object.
    * @return the long representation of this RestrictedLong object.
    */
   public long toLong ()
   {
      return mRestrictedLong;
   }

   /**
    * Returns the Long representation of this RestrictedLong object.
    * @return the Long representation of this RestrictedLong object.
    */
   public Long toLongObject ()
   {
      if (mRestrictedLongLongObject == null)
      {
         mRestrictedLongLongObject = new Long(mRestrictedLong);
      }
      return mRestrictedLongLongObject;
   }

   /** {@inheritDoc} */
   public String toString ()
   {
      return Long.toString(mRestrictedLong);
   }

   /** {@inheritDoc} */
   public boolean equals (Object obj)
   {
      return (this == obj)
        || (obj instanceof RestrictedLong
            && ((RestrictedLong) obj).mRestrictedLong
               == mRestrictedLong);
   }

   /** {@inheritDoc} */
   public int hashCode ()
   {
      if (mHashCode == 0)
      {
         mHashCode = HashCodeUtil.hash(HashCodeUtil.SEED, mRestrictedLong);
      }
      return mHashCode;
   }

   /**
    * Compares this RestrictedLong with an other.
    * The order is based on the numeric order of the
    * of the compared instances.
    *
    * @return a negative integer, zero, or a positive integer as this
    *   object is less than, equal to, or greater than the specified object.
    * @throws ClassCastException if the specified object's type prevents
    *   it from being compared to this Object.
    * @see Long#compareTo(Object)
    */
   public int compareTo(Object o)
   {
     final long thisVal = toLong();
     final long anotherVal = ((RestrictedLong) o).toLong();
     return (thisVal < anotherVal ? -1 : (thisVal == anotherVal ? 0 : 1));
   }

}
