/*
 * Generated source file, not in CVS/SVN repository
 */
package org.jcoderz.commons.types;


import java.io.Serializable;

import org.jcoderz.commons.ArgumentMinLengthViolationException;
import org.jcoderz.commons.ArgumentMaxLengthViolationException;
import org.jcoderz.commons.ArgumentMalformedException;
import org.jcoderz.commons.util.Assert;


/**
 * Holds the Url.
 * <pre>
 * String.type[1..1024].
 * </pre>
 * Instances of this class are immutable.
 *
 * <p>This class implements the Comparable interface based on the natural
 * order of the String representation of its instances.</p>
 *
 * @author generated via stylesheet
 */
public final class Url
      implements Serializable, org.jcoderz.commons.RestrictedString, Comparable<Object>
{
   /**
    * Url - the name of this type as string constant.
    */
   public static final String TYPE_NAME = "Url";

   /** The minimal length of Url (1). */
   public static final int MIN_LENGTH = 1;

   /** The maximal length of Url (1024). */
   public static final int MAX_LENGTH = 1024;

   /** The serialVersionUID used for serialization. */
   static final long serialVersionUID = 1;

   /** Holds the Url. */
   private final String mUrl;

   /**
    * Creates a new instance of a Url.
    *
    * @param str the Url as string representation.
    * @throws ArgumentMalformedException If the given string <code>str</code>
    *         violates the restriction of this type.
    */
   private Url (final String str)
         throws ArgumentMalformedException
   {
      Assert.notNull(str, TYPE_NAME);
      if (str.length() < MIN_LENGTH)
      {
         throw new ArgumentMinLengthViolationException(
            TYPE_NAME,
            str, new Integer(str.length()), new Integer(MIN_LENGTH),
            Url.class);
      }
      if (str.length() > MAX_LENGTH)
      {
         throw new ArgumentMaxLengthViolationException(
            TYPE_NAME,
            str, new Integer(str.length()), new Integer(MAX_LENGTH),
            Url.class);
      }
      mUrl = str;
   }

   /**
    * Creates a Url object from the String representation.
    *
    * @param str The str representation of the Url to be returned.
    * @return The Url object represented by this str.
    * @throws ArgumentMalformedException If the given string <code>str</code>
    *         violates the restriction of this type.
    */
   public static Url fromString (String str)
         throws ArgumentMalformedException
   {
      return new Url(str);
   }

   /**
    * Returns the String representation of this Url.
    *
    * @return The String representation of this Url.
    */
   public String toString ()
   {
      return mUrl;
   }

   /**
    * Indicates whether some other object is "equal to" this one.
    *
    * @param obj the object to compare to.
    * @return true if this object is the same as the obj argument; false
    *         otherwise.
    */
   public boolean equals (Object obj)
   {
      return (this == obj)
        || (obj instanceof Url
            && ((Url) obj).mUrl.equals(
               mUrl));
   }

   /**
    * Returns the hash code for the Url.
    *
    * @return the hash code for the Url.
    */
   public int hashCode ()
   {
      return mUrl.hashCode();
   }

   /**
    * Compares this Url with an other.
    * The order is based on the natural order of the String representation
    * of the compared instances.
    *
    * @param o the Object to be compared.   
    * @return a negative integer, zero, or a positive integer as this
    *   object is less than, equal to, or greater than the specified object.
    * @throws ClassCastException if the specified object's type prevents
    *   it from being compared to this Object.
    * @see String#compareTo(Object)
    */
   public int compareTo(Object o)
   {
      return toString().compareTo(
        ((Url) o).toString());
   }
}
